#include "scr_ml.h"
#include <time.h>
#include <stdio.h>

/*
int scr_getch(void); //think about it, damn it
*/

typedef struct {
unsigned char x;
unsigned char y;
} curs_pair;

void test_scrollarea(void) 
{
scr_mvprintf(5,5,"this is first line to scroll ");
scr_mvprintf(5,6,"this is second line to scroll");
scr_mvprintf(5,7,"this is third line to scroll ");
scr_mvprintf(5,8,"this is forth line to scroll ");
scr_mvprintf(10,24,"SCROLL AREA TEST                            ");
scr_drawbox(4,4,strlen("this is second line to scroll")+2,6);
scr_refresh();
scr_getch();
scr_scrollarea(5,5,29,4);
scr_refresh();
}


void test_clrarea(void) 
{
scr_mvprintf(10,24,"CLRAREA TEST                            ");
scr_clrarea(15,3,10,5);
scr_mvprintf(6,10,"You should see cleared 10x5 area");
scr_refresh();
}
    
void test_cursor(void) 
{
unsigned char x,y,f;
curs_pair carr[]={
{1,1},
{2,2},
{5,5},
{1,5},
{5,1},
};

scr_mvprintf(10,24,"CURSOR TEST        ");
scr_refresh();
for (f=0;f<(sizeof(carr)/sizeof(carr[0]));f++) {
x=carr[f].x;
y=carr[f].y;
scr_mvprintf(10,12,"Cursor should be at: %u,%u",x,y);
scr_cursor(x,y);
scr_refresh();
scr_getch();
};
scr_hidecursor();
scr_mvprintf(10,12,"Cursor should disappear       ");
scr_refresh();
scr_getch();
scr_showcursor();
scr_mvprintf(10,12,"Cursor should reappear       ");
scr_refresh();
}

void test_mvaddch(void)
{
unsigned char f,g;
scr_mvprintf(0,24,"MVADDCH TEST        ");
for (f=0;f<24;f++) {
  for (g=0;g<80;g++) {
  scr_mvaddch(g,f,scr_to_scr_char(33+g,scr_color2attr(SCR_CF_WHITE | SCR_CB_BLACK)));
  };
}
scr_mvprintf(6,10,"You should see UNcolored lines of letters");
scr_refresh();
}

void test_palette(void)
{
unsigned int f,g;
unsigned int cf[]={
SCR_CF_BLACK,
SCR_CF_RED,
SCR_CF_GREEN,
SCR_CF_YELLOW,
SCR_CF_BLUE,
SCR_CF_MAGENTA,
SCR_CF_CYAN,
SCR_CF_WHITE
};

unsigned int cb[]={
SCR_CB_BLACK,
SCR_CB_RED,
SCR_CB_GREEN,
SCR_CB_YELLOW,
SCR_CB_BLUE,
SCR_CB_MAGENTA,
SCR_CB_CYAN,
SCR_CB_WHITE
};

char* cn[]={
"black",
"red",
"green",
"yellow",
"blue",
"magenta",
"cyan",
"white"
};

scr_mvprintf(10,24,"PALETTE TEST        ");
scr_refresh();

for (f=0;f<(sizeof(cf)/sizeof(cf[0]));f++) {
for (g=0;g<(sizeof(cb)/sizeof(cb[0]));g++) {
  scr_curr_attr=scr_color2attr(cf[f] | cb[g]);
  scr_mvprintf((g*20)%scr_width,3*f+((g*20)/scr_width),"%s on %s",cn[f],cn[g]);
  };
};
scr_curr_attr=scr_color2attr(SCR_CF_WHITE | SCR_CB_BLACK);
scr_refresh();
}


void test_area(void)
{
scr_char* area;
scr_mvprintf(10,24,"AREA TEST            ");
scr_refresh();
area=scr_getarea(1,1,10,10);
scr_putarea(40,10,10,10,area);
scr_freearea(area);
scr_refresh();
}


void test_addch(void)
{
unsigned char f;
scr_mvprintf(10,24,"ADDCH  TEST           ");
scr_refresh();
scr_locate(40,15);
for (f=0;f<60;f++) {
scr_addch(scr_to_scr_char(32+f,scr_color2attr(SCR_CF_GREEN | SCR_CB_BLACK)));
};
scr_mvprintf(6,10,"You should see a wrapping line, fore green");
scr_refresh();
}

void test_drawbox(void)
{
unsigned char f,g;
scr_mvprintf(10,24,"DRAWBOX TEST            ");
scr_refresh();
for (f=2;f<20;f++) {
    for (g=2;g<60;g++) {
    scr_drawbox(1,1,g,f);
    scr_refresh();
    };
};
}

int main(void)
{
scr_initscr();
scr_getch();
test_cursor();
scr_getch();
scr_curr_attr=scr_color2attr(SCR_CF_WHITE | SCR_CB_BLACK);// 0x53;
//printf("Width,height = %u,%u",scr_width,scr_height);
scr_locate(0,0);
scr_mvprintf(10,10,"Width,height = %u,%u",scr_width,scr_height);
scr_refresh();
test_palette();
scr_getch();
test_mvaddch();
scr_getch();
test_area();
scr_getch();
test_addch();
scr_getch();
test_drawbox();
scr_getch();
test_clrarea();
scr_getch();
test_scrollarea();
scr_getch();
scr_stopscr();
return 0;
}
