
void scr_refresh(void) {
scr_refresh_ind_linewise();
gotoxy(scr_curs_x+1, scr_curs_y+1);
}

//inits just the character device, not any memory
void scr_initscr_low(void)
{
clrscr();
gotoxy(1,1);
}

void scr_stopscr_low(void) //deinits just the character device
{
clrscr();
}

void scr_cursor(unsigned char x,unsigned char y)
{
scr_curs_y=y;
scr_curs_x=x;
}

void scr_hidecursor(void)
{
_setcursortype(_NOCURSOR);
}

void scr_showcursor(void)
{
_setcursortype(_NORMALCURSOR);
}

int scr_getch(void)
{
int tmpchar;
tmpchar=getxkey();
switch (tmpchar)
     {
     case K_EUp:
          return SCR_KEY_UP;
     case K_EDown:
          return SCR_KEY_DOWN;
     case K_ELeft:
          return SCR_KEY_LEFT;
     case K_ERight:
          return SCR_KEY_RIGHT;
     case K_EPageUp:
          return SCR_KEY_PAGEUP;
     case K_EPageDown:
          return SCR_KEY_PAGEDOWN;
     case K_EEnd:
          return SCR_KEY_END;
     case K_EInsert:
          return SCR_KEY_INSERT;
     case K_EDelete:
          return SCR_KEY_DELETE;
     case K_EHome:
          return SCR_KEY_HOME;
     case 13:
          return SCR_KEY_ENTER;
     case 27:
          return SCR_KEY_ESC;
     case 9:
          return SCR_KEY_TAB;
     default: //untranslated
          return tmpchar;
     };
}

int scr_getch_nowait(void)
{
int tmpchar;
tmpchar=_conio_kbhit();
if (tmpchar) return scr_getch();
return SCR_KEY_NONE;
}


unsigned char scr_maxx(void)
{
return 80;
} //screen width

unsigned char scr_maxy(void) //screen height
{
return 25;
}

//type conversion functions:
unsigned char scr_char2char(scr_char ch)
{
return ((unsigned char) (ch & 0xFF));
}

scr_attr scr_char2attr(scr_char ch)
{
return (ch & 0xFF00);
}

scr_char scr_to_scr_char(unsigned char ch, scr_attr attr)
{
return (((short int) attr << 8) | ch);
}

scr_attr scr_color2attr(unsigned int color)
{
return (short int) color;
}

unsigned char scr_charcomp(scr_char ch1,scr_char ch2)
{
return (ch1==ch2);
}

//for linewise method:
void scr_drv_showline(unsigned char x, unsigned char y,
                  unsigned char xlen, scr_char* line)
{
unsigned char f;
puttext(x+1,y+1,x+xlen+1,y+1,line); //???
}

//for 'teletype' method:
void scr_drv_home(void)  //position to 0:0
{
}

void scr_drv_skiplines(unsigned char lines) //skip so much lines
{
}

void scr_drv_skipchars(unsigned char chars) //skip so much chars
{
}

void scr_drv_showstring(unsigned char len, scr_char* line)
{
}

