#include "scr_drv.h"
#include "scr_ind.h"
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <stdarg.h>
#include <stdio.h>

//This is an abstract, portable but very simple interface to screen
//It's lowest level platform-dependent drivers 
//It's compiled in if ncurses aren't.
//Ncurses covers both this part and platform-independend one, so it lacks
//functions which must be implemented by ALL the other drivers!

#ifdef NCURDEBUG
//it's for debugging
#include "scr_ncur.c"
#endif

#ifdef DOSCONIO
#include "scr_dos.c"
#endif

#ifdef WINAPIDRV
#include "scr_win.c"
#endif

#ifdef MINIXCURSES
#include "scr_cur.c"
#endif

