#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <stdarg.h>
#include "scr_ml.h"
//#include <dmalloc.h>
//This is an abstract, portable but very simple interface to screen
//It's midlevel part. One for all.

void scr_widget_destroy(void* widget)
{
//I can do this better, as I have header.widgtype...
free(widget);
}

//untested
void scr_clrarea(unsigned char x,unsigned char y, unsigned char xlen,
		         unsigned char ylen)
{
scr_char tmpchar;
unsigned char f;
unsigned char g;
tmpchar=scr_to_scr_char(' ',scr_getattr());
for (f=y;f<y+ylen;f++) {
    for (g=x;g<x+xlen;g++) {
    scr_mvaddch(g,f,tmpchar);
    };
};
}

//untested
void scr_scrollarea(unsigned char x,unsigned char y, unsigned char xlen,
		         unsigned char ylen)
{
scr_char tmpchar;
unsigned char f;
unsigned char g;
for (f=y+1;f<y+ylen;f++) {
    for (g=x;g<x+xlen;g++) {
    tmpchar=scr_mvinch(g,f);
    scr_mvaddch(g,f-1,tmpchar);
    };
};
scr_clrarea(x,y+ylen-1,xlen,1);
}

void scr_drawbox(unsigned char x,unsigned char y, unsigned char xlen,
	         unsigned char ylen)
{
unsigned char f;
scr_char tmpchar;
scr_attr currattr;
if ((xlen<2) || (ylen<2)) return;
xlen--; ylen--;
currattr=scr_getattr();
tmpchar=scr_to_scr_char('', currattr);
/* Draw horizontal lines. */
for (f=1; f<xlen;f++) 
{
  scr_mvaddch (x+f, y, tmpchar);
  scr_mvaddch (x+f, y+ylen, tmpchar);
}

tmpchar=scr_to_scr_char('', currattr);
/* Draw vertical lines. */
for (f=1; f<ylen;f++) 
{
  scr_mvaddch (x, y+f, tmpchar);
  scr_mvaddch (x+xlen, y+f, tmpchar);
}

/* corners */
scr_mvaddch (x, y, scr_to_scr_char('', currattr));
scr_mvaddch (x+xlen, y, scr_to_scr_char('', currattr));
scr_mvaddch (x, y+ylen, scr_to_scr_char('', currattr));
scr_mvaddch (x+xlen, y+ylen, scr_to_scr_char('', currattr));
}


void scr_drawshadow(unsigned char x,unsigned char y, unsigned char xlen,
	         unsigned char ylen)
{
//should draw shadow, but later
(void) x;
(void) y;
(void) xlen;
(void) ylen;
}

//here must be a cut-out of string by length!
Scr_label* scr_label_create(unsigned char x, unsigned char y,
	unsigned char len, char* text)
{
Scr_label* tmplabel;
tmplabel=malloc(sizeof(Scr_label));
if (!tmplabel) return NULL;
tmplabel->header.widgtype=SCR_WT_LABEL;
tmplabel->header.x=x;
tmplabel->header.y=y;
tmplabel->header.xlen=len;
tmplabel->header.ylen=1;
tmplabel->header.color=scr_curr_attr; //default
tmplabel->text=text;
return tmplabel;
}

void scr_label_draw(Scr_label* label)
{
unsigned char f;
unsigned char y;
unsigned char x;
scr_setattr(label->header.color);
y=label->header.y;
x=label->header.x;
f=0;
while ((label->text[f]!='\0') && (f<label->header.xlen))
{
scr_mvaddch(x+f,y,scr_to_scr_char(label->text[f],scr_curr_attr));
f++;
}
}

Scr_mlabel* scr_mlabel_create(unsigned char x, unsigned char y,
	unsigned char xlen, unsigned char ylen, char** lines)
{
Scr_mlabel* tmplabel;
tmplabel=malloc(sizeof(Scr_mlabel));
if (!tmplabel) return NULL;
tmplabel->header.widgtype=SCR_WT_MLABEL;
tmplabel->header.x=x;
tmplabel->header.y=y;
tmplabel->header.xlen=xlen;
tmplabel->header.ylen=ylen;
tmplabel->header.color=scr_curr_attr; //default
tmplabel->lines=lines;
return tmplabel;
}

void scr_mlabel_draw(Scr_mlabel* mlabel)
{
unsigned char f; unsigned char g;
unsigned char y; unsigned char x;

scr_setattr(mlabel->header.color);
y=mlabel->header.y;
x=mlabel->header.x;

  for (f=0;f<mlabel->header.ylen;f++) {
  g=0;
    while ((mlabel->lines[f][g]!='\0') && (g<mlabel->header.xlen)) {
      scr_mvaddch(x+g,y+f,scr_to_scr_char(mlabel->lines[f][g],scr_curr_attr));
      g++;
      };
  };
}

	
//I can do alternative scr_box(widget) for all. Should I?
//Also,  I can use void* newwigget(widgettype)

Scr_menu* scr_menu_create(unsigned char x, unsigned char y, char** choices,
	unsigned char numchoices)
{
//+1. adapt it automatically to length of strings?
//-2. Do any kind of alignment?
//3. Draw a box around or not? shadow?
//4. Use title or not (when it is boxed?)
Scr_menu* tmpmenu;
unsigned char f,tmplen,tmpmax;
tmpmenu=malloc(sizeof(Scr_menu));
if (!tmpmenu) return NULL;
tmpmenu->header.widgtype=SCR_WT_MENU;
tmpmenu->header.x=x;
tmpmenu->header.y=y;
tmpmenu->header.ylen=numchoices;
tmpmenu->header.color=scr_curr_attr; //default
tmpmenu->choices=choices;
tmpmenu->numchoices=numchoices;
tmpmenu->exittype=0; //never started
tmpmenu->currchoice=0; //from 0?
tmpmenu->selattr=scr_color2attr(SCR_CF_BLACK | SCR_CB_WHITE); //default

tmpmax=0;
for (f=0;f<numchoices;f++) {
tmplen=strlen(choices[f]);
if (tmplen>tmpmax) tmpmax=tmplen; 
}
tmpmenu->header.xlen=tmpmax; //computed from maximum choice length
return tmpmenu;
}

//this fully redraws a menu
void scr_menu_draw(Scr_menu* menu)
{
unsigned char f,y;
scr_setattr(menu->header.color);
y=menu->header.y;
 for (f = 0; f < menu->numchoices; f++)
 {
     if (menu->currchoice == f) /* High light the present choice */
         {
	 scr_setattr(menu->selattr);
         }
     scr_mvprintf(menu->header.x, y,"%s",menu->choices[f]);
     scr_setattr(menu->header.color);
 y++; //next y
 }
}

int scr_menu_inject(Scr_menu* menu,int thechar)
{
//chars injected here...
unsigned char highlight;
int ecode;

highlight=menu->currchoice;
ecode=SCR_EC_OK;
switch (thechar)
     {     
     case SCR_KEY_UP:
          if (highlight == 0) highlight = menu->numchoices-1; else highlight--;
          break;
     case SCR_KEY_DOWN:
	  highlight++;
 	  if (highlight >= menu->numchoices) highlight=0;
	  break;
     case SCR_KEY_ENTER: 
          ecode=SCR_EC_ENTER;
	  break;
     case SCR_KEY_ESC:
          ecode=SCR_EC_ESC;
	  break;
     default: //unrecognized 
          ecode=SCR_EC_UNK;
          break;
     };
menu->currchoice=highlight;
scr_menu_draw(menu);
menu->exittype=ecode;
return ecode;
}

//--------------------------EDIT--------------------------

Scr_edit* scr_edit_create(unsigned char x, unsigned char y, unsigned char len, 
	char* text)
{
Scr_edit* tmpedit;
tmpedit=malloc(sizeof(Scr_edit));
if (!tmpedit) return NULL;
tmpedit->header.widgtype=SCR_WT_EDIT;
tmpedit->header.x=x;
tmpedit->header.y=y;
tmpedit->header.ylen=1;
tmpedit->header.xlen=len;
tmpedit->header.color=scr_curr_attr; //default

tmpedit->currpos=0;
tmpedit->exittype=0; //never started
tmpedit->text=text;
tmpedit->prefilter=NULL;

return tmpedit;
}

void scr_edit_draw(Scr_edit* edit)
{
//should print to whole length here!
unsigned char len;
unsigned char f;
unsigned char state;
char tmpchar;

state=0;
len=edit->header.xlen;
for (f=0;f<len;f++)
    {
    tmpchar=edit->text[f];
    if (tmpchar=='\0') state=1;
	if (!state) {
	scr_mvaddch(edit->header.x+f, edit->header.y, 
		scr_to_scr_char(tmpchar,scr_curr_attr));
	} else {
	scr_mvaddch(edit->header.x+f, edit->header.y, 
		scr_to_scr_char(' ',scr_curr_attr));
	};
    };
scr_cursor(edit->header.x+edit->currpos,edit->header.y);
}


int scr_edit_inject(Scr_edit* edit,int thechar)
{
//chars injected here...
int ecode; 
unsigned char currpos;
unsigned char currlen;
//call preprocessing filter first, if it exists:
if (edit->prefilter) thechar=edit->prefilter(thechar);

currpos=edit->currpos;
currlen=strlen(edit->text);
ecode=SCR_EC_UNK;

switch (thechar)
     {     
     case SCR_KEY_LEFT:
          if (currpos>0) currpos--;
          break;
     case SCR_KEY_RIGHT:
          if (currpos<currlen) currpos++;
          break;
     case SCR_KEY_BACKSPACE:
          if (currpos>0) {
	      currpos--; 
	      (void) memmove(edit->text+currpos,edit->text+currpos+1,
			     currlen-currpos);
	  };
          break;
     case SCR_KEY_DELETE:
	      (void) memmove(edit->text+currpos,edit->text+currpos+1,
			     currlen-currpos);
          break; 
     case SCR_KEY_ENTER:
          ecode=SCR_EC_ENTER;
	  break;
     case SCR_KEY_ESC:
          ecode=SCR_EC_ESC;
	  break;
     default: //try to print all other codes
	  if (thechar<256)  { //ignore if too big (simple check)
	      if (currlen<edit->header.xlen) {
              //insert char into current pos.
	      //memmove is safe because len is already checked
	         (void) memmove(edit->text+currpos+1,edit->text+currpos,
			     currlen-currpos+1); // CHECKED?
              edit->text[currpos]=thechar;
	      currpos++; 
	      }
	  ecode=SCR_EC_OK;
	  };
          break;
     };
edit->currpos=currpos;
edit->exittype=ecode;
scr_edit_draw(edit);
return ecode;
}

//--------------------------MEMO--------------------------

Scr_memo* scr_memo_create(unsigned char x, unsigned char y, unsigned char xlen, 
	unsigned char ylen, char** lines)
{
Scr_memo* tmpmemo;
tmpmemo=malloc(sizeof(Scr_memo));
if (!tmpmemo) return NULL;
tmpmemo->header.widgtype=SCR_WT_MEMO;
tmpmemo->header.x=x;
tmpmemo->header.y=y;
tmpmemo->header.ylen=ylen;
tmpmemo->header.xlen=xlen;
tmpmemo->header.color=scr_curr_attr; //default

tmpmemo->currpos=0;
tmpmemo->currline=0;
tmpmemo->exittype=0; //never started
tmpmemo->lines=lines;
tmpmemo->prefilter=NULL;

return tmpmemo;
}

void scr_memo_draw(Scr_memo* memo)
{
//should print to whole lengthS here!
unsigned char xlen;
unsigned char ylen;
unsigned char f;
unsigned char g;
unsigned char state;
char tmpchar;

xlen=memo->header.xlen;
ylen=memo->header.ylen;

for (f=0;f<ylen;f++) {
 state=0;
    for (g=0;g<xlen;g++)
	{
	tmpchar=memo->lines[f][g];
	if (tmpchar=='\0') state=1;
	    if (!state) {
	    scr_mvaddch(memo->header.x+g, memo->header.y+f, 
		    scr_to_scr_char(tmpchar,scr_curr_attr));
	    } else {
	    scr_mvaddch(memo->header.x+g, memo->header.y+f, 
		    scr_to_scr_char(' ',scr_curr_attr));
	    };
	};
};
scr_cursor(memo->header.x+memo->currpos,memo->header.y+memo->currline);
}

int scr_memo_inject(Scr_memo* memo,int thechar)
{
//chars injected here...
int ecode; 
unsigned char currpos;
unsigned char currlen;
unsigned char newlen;
unsigned char currline;

//call preprocessing filter first, if it exists:
if (memo->prefilter) thechar=memo->prefilter(thechar);

currpos=memo->currpos;
currline=memo->currline;
currlen=strlen(memo->lines[currline]);
ecode=SCR_EC_UNK;

switch (thechar)
     {     
     case SCR_KEY_UP:
          if (currline>0) {
	  //here, we should correctly position cursor on new line
	  currline--;
	  newlen=strlen(memo->lines[currline]);
	  if (newlen<currpos) currpos=newlen; //else leave as is
	  };
          break;
     case SCR_KEY_DOWN:
          if (currline<(memo->header.ylen-1)) {
	  //here, we should correctly position cursor on new line
	  currline++;
	  newlen=strlen(memo->lines[currline]);
	  if (newlen<currpos) currpos=newlen; //else leave as is
	  };
          break;
     case SCR_KEY_LEFT:
          if (currpos>0) currpos--;
          break;
     case SCR_KEY_RIGHT:
          if (currpos<currlen) currpos++;
          break;
     case SCR_KEY_BACKSPACE:
          if (currpos>0) {
	      currpos--; 
	      (void) memmove(memo->lines[currline]+currpos,
			     memo->lines[currline]+currpos+1,
			     currlen-currpos);
	  };
          break;
     case SCR_KEY_DELETE:
	      (void) memmove(memo->lines[currline]+currpos,
			     memo->lines[currline]+currpos+1,
			     currlen-currpos);
          break; 
     case SCR_KEY_ENTER:
          ecode=SCR_EC_ENTER;
	  break;
     case SCR_KEY_ESC:
          ecode=SCR_EC_ESC;
	  break;
     default: //try to print all other codes
	  if (thechar<256)  { //ignore if too big (simple check)
	      if (currlen<(memo->header.xlen)) {
              //insert char into current pos.
	      (void) memmove(memo->lines[currline]+currpos+1,
			     memo->lines[currline]+currpos,
			     currlen-currpos+1); //CHECKED?
              memo->lines[currline][currpos]=thechar;
	      currpos++; 
	      }
	  ecode=SCR_EC_OK;
	  };
          break;
     };
memo->currpos=currpos;
memo->currline=currline;
memo->exittype=ecode;
scr_memo_draw(memo);
return ecode;
}

//------------------------- CHECK_GROUP -----------------------
Scr_checkgrp* scr_checkgrp_create(unsigned char x, unsigned char y, 
	unsigned char numchoices, 
	char** choices,	char* chosens)
{
Scr_checkgrp* tmpcheckgrp;
unsigned char f,tmplen,tmpmax;
tmpcheckgrp=malloc(sizeof(Scr_checkgrp));
if (!tmpcheckgrp) return NULL;
tmpcheckgrp->header.widgtype=SCR_WT_CHECKGRP;
tmpcheckgrp->header.x=x;
tmpcheckgrp->header.y=y;
tmpcheckgrp->header.ylen=numchoices;
tmpcheckgrp->header.color=scr_curr_attr; //default

tmpcheckgrp->choices=choices;
tmpcheckgrp->chosens=chosens;
tmpcheckgrp->exittype=0; //never started
tmpcheckgrp->currchoice=0; //from 0?
tmpcheckgrp->selattr=scr_color2attr(SCR_CF_BLACK | SCR_CB_WHITE); //default
tmpcheckgrp->prefilter=NULL;

tmpmax=0;
for (f=0;f<numchoices;f++) {
tmplen=strlen(choices[f]);
if (tmplen>tmpmax) tmpmax=tmplen; 
}
tmpcheckgrp->header.xlen=tmpmax+4; //computed from maximum choice length
return tmpcheckgrp;
}

//this fully redraws a checkgrp
void scr_checkgrp_draw(Scr_checkgrp* checkgrp)
{
unsigned char f,y;
scr_setattr(checkgrp->header.color);
y=checkgrp->header.y;
 for (f = 0; f < checkgrp->header.ylen; f++)
 {
     if (checkgrp->currchoice == f) /* High light the present choice */
         {
	 scr_setattr(checkgrp->selattr);
         }
     if (checkgrp->chosens[f]) {
     scr_mvprintf(checkgrp->header.x, y,"[x] %s",checkgrp->choices[f]);
     } else {
     scr_mvprintf(checkgrp->header.x, y,"[ ] %s",checkgrp->choices[f]);
     }
     scr_setattr(checkgrp->header.color);
 y++; //next y
 }
scr_cursor(checkgrp->header.x+1, checkgrp->header.y+checkgrp->currchoice);
}

int scr_checkgrp_inject(Scr_checkgrp* checkgrp, int thechar)
{
//chars injected here...
unsigned char highlight;
int ecode;

if (checkgrp->prefilter) thechar=checkgrp->prefilter(thechar);

highlight=checkgrp->currchoice;
ecode=SCR_EC_OK;
switch (thechar)
     {     
     case SCR_KEY_UP:
          if (!highlight) highlight=checkgrp->header.ylen-1; else highlight--;
          break;
     case SCR_KEY_DOWN:
	  highlight++;
 	  if (highlight >= checkgrp->header.ylen) highlight=0;
	  break;
     case SCR_KEY_ENTER:
          ecode=SCR_EC_ENTER;
	  break;
     case SCR_KEY_ESC: 
          ecode=SCR_EC_ESC;
	  break;
     case ' ': 
          checkgrp->chosens[highlight]=!(checkgrp->chosens[highlight]);
	  break;
     default: //unrecognized 
          ecode=SCR_EC_UNK;
          break;
     };
checkgrp->currchoice=highlight;
scr_checkgrp_draw(checkgrp);
checkgrp->exittype=ecode;
return ecode;
}

//========== HORIZONTAL PROGRESS BAR ==========================

Scr_hprogrbar* scr_hprogrbar_create(unsigned char x, unsigned char y, 
	unsigned char len)
{
Scr_hprogrbar* tmpbar;
tmpbar=malloc(sizeof(Scr_hprogrbar));
if (!tmpbar) return NULL;
tmpbar->header.widgtype=SCR_WT_HPROGRBAR;
tmpbar->header.x=x;
tmpbar->header.y=y;
tmpbar->header.ylen=1;
tmpbar->header.xlen=len;
tmpbar->header.color=scr_curr_attr; //default
tmpbar->currpos=0;
return tmpbar;
}

void scr_hprogrbar_draw(Scr_hprogrbar* bar)
{
unsigned char f,tmpsize;
scr_attr tmpattr;
tmpsize=bar->currpos/2;

if (bar->currpos > 2*bar->header.xlen) return;
scr_clrarea(bar->header.x,bar->header.y,bar->header.xlen,1);

tmpattr=bar->header.color;

for (f=0;f<tmpsize;f++) {
  scr_mvaddch(bar->header.x+f,bar->header.y,scr_to_scr_char('',tmpattr));
};

if (bar->currpos%2) 
{ 
scr_mvaddch(bar->header.x+tmpsize,bar->header.y,scr_to_scr_char('',tmpattr));
};

}

//========== VERTICAL PROGRESS BAR ==========================

Scr_vprogrbar* scr_vprogrbar_create(unsigned char x, unsigned char y, 
	unsigned char len)
{
Scr_vprogrbar* tmpbar;
tmpbar=malloc(sizeof(Scr_vprogrbar));
if (!tmpbar) return NULL;
tmpbar->header.widgtype=SCR_WT_VPROGRBAR;
tmpbar->header.x=x;
tmpbar->header.y=y;
tmpbar->header.xlen=1;
tmpbar->header.ylen=len;
tmpbar->header.color=scr_curr_attr; //default
tmpbar->currpos=0;
return tmpbar;
}

void scr_vprogrbar_draw(Scr_vprogrbar* bar)
{
unsigned char f,tmpsize;
scr_attr tmpattr;
tmpsize=bar->currpos/2;

if (bar->currpos > 2*bar->header.ylen) return;
scr_clrarea(bar->header.x,bar->header.y,1,bar->header.ylen);

tmpattr=bar->header.color;

for (f=0;f<tmpsize;f++) {
  scr_mvaddch(bar->header.x,bar->header.y+f,scr_to_scr_char('',tmpattr));
};

if (bar->currpos%2) 
{ 
scr_mvaddch(bar->header.x,bar->header.y+tmpsize,scr_to_scr_char('',tmpattr));
};

}

//========== VERTICAL SCROLL BAR ==========================

Scr_vscrollbar* scr_vscrollbar_create(unsigned char x, unsigned char y, 
	unsigned char len)
{
Scr_vscrollbar* tmpbar;
tmpbar=malloc(sizeof(Scr_vscrollbar));
if (!tmpbar) return NULL;
tmpbar->header.widgtype=SCR_WT_VSCROLLBAR;
tmpbar->header.x=x;
tmpbar->header.y=y;
tmpbar->header.xlen=1;
tmpbar->header.ylen=len;
tmpbar->header.color=scr_curr_attr; //default
tmpbar->currpos=0;
return tmpbar;
}

void scr_vscrollbar_draw(Scr_vscrollbar* bar)
{
unsigned char f,tmpsize;
scr_attr tmpattr;

tmpsize=bar->header.ylen;
if (bar->currpos>tmpsize) return;
tmpattr=bar->header.color;

for (f=0;f<tmpsize;f++) {
   if (f==bar->currpos) 
   {
   scr_mvaddch(bar->header.x,bar->header.y+f,scr_to_scr_char('',tmpattr));
   } else 
   {
   scr_mvaddch(bar->header.x,bar->header.y+f,scr_to_scr_char('',tmpattr));
   };
};

}

//========== HORIZONTAL SCROLL BAR ==========================

Scr_hscrollbar* scr_hscrollbar_create(unsigned char x, unsigned char y, 
	unsigned char len)
{
Scr_hscrollbar* tmpbar;
tmpbar=malloc(sizeof(Scr_hscrollbar));
if (!tmpbar) return NULL;
tmpbar->header.widgtype=SCR_WT_HSCROLLBAR;
tmpbar->header.x=x;
tmpbar->header.y=y;
tmpbar->header.ylen=1;
tmpbar->header.xlen=len;
tmpbar->header.color=scr_curr_attr; //default
tmpbar->currpos=0;
return tmpbar;
}

void scr_hscrollbar_draw(Scr_hscrollbar* bar)
{
unsigned char f,tmpsize;
scr_attr tmpattr;
tmpsize=bar->header.xlen;
if (bar->currpos>tmpsize) return;
tmpattr=bar->header.color;

for (f=0;f<tmpsize;f++) {
   if (f==bar->currpos) 
   {
   scr_mvaddch(bar->header.x+f,bar->header.y,scr_to_scr_char('',tmpattr));
   } else 
   {
   scr_mvaddch(bar->header.x+f,bar->header.y,scr_to_scr_char('',tmpattr));
   };
};

}
//---------------- VIEWER ----------------------------
Scr_viewer* scr_viewer_create(unsigned char x, unsigned char y,
	unsigned char xlen, unsigned char ylen, char** lines, 
	unsigned int numlines)
{
Scr_viewer* tmpview;
tmpview=malloc(sizeof(Scr_viewer));
if (!tmpview) return NULL;
tmpview->header.widgtype=SCR_WT_VIEWER;
tmpview->header.x=x;
tmpview->header.y=y;
tmpview->header.xlen=xlen;
tmpview->header.ylen=ylen;
tmpview->header.color=scr_curr_attr; //default
tmpview->lines=lines;
tmpview->numlines=numlines;
tmpview->exittype=0; //never started
tmpview->startline=0;
return tmpview;
}

void scr_viewer_draw(Scr_viewer* viewer)
{
unsigned char f,g,x,y,state;
char tmpchar;
unsigned int currline;
//here, we must draw correctly, even if numlines<startline
scr_setattr(viewer->header.color);
y=viewer->header.y;
x=viewer->header.x;

currline=viewer->startline;
for (f=0;f<viewer->header.ylen;f++) {
if (currline < viewer->numlines) {
    state=0;
    for (g=0;g<viewer->header.xlen;g++)
	{
	tmpchar=viewer->lines[currline][g];
	if (tmpchar=='\0') state=1;
	    if (!state) {
	    scr_mvaddch(x+g, y+f, scr_to_scr_char(tmpchar,scr_curr_attr));
	    } else {
	    scr_mvaddch(x+g, y+f, scr_to_scr_char(' ',scr_curr_attr));
	    };
	};
    } else {
    //clean the line
    scr_clrarea(x, y+f, viewer->header.xlen, 1);
    };
currline++;
}

}

int scr_viewer_inject(Scr_viewer* viewer,int thechar)
{
//chars injected here...
unsigned char ecode;
unsigned int currstart;

currstart=viewer->startline;
ecode=SCR_EC_OK;
switch (thechar)
     {     
     case SCR_KEY_UP:
	  if (currstart) currstart--; 
          break;
     case SCR_KEY_DOWN:
	  if ((currstart+viewer->header.ylen) < viewer->numlines) {
          currstart++;
	  }
	  break;
	  //a page height is header.ylen
     case SCR_KEY_PAGEUP:
	  if (currstart > viewer->header.ylen) {
          currstart-=viewer->header.ylen;
          } else currstart=0;
          break;
     case SCR_KEY_PAGEDOWN:
	  if (currstart+2*viewer->header.ylen < viewer->numlines) {
          currstart+=viewer->header.ylen;
	//	  scr_mvprintf(70,23,"<");
          } else {
	      if (viewer->numlines < viewer->header.ylen) {
	      currstart=0;
	//	  scr_mvprintf(70,23,"0");
	      } else {
	      currstart=viewer->numlines-viewer->header.ylen;
	//	  scr_mvprintf(70,23,"-");
	      };
	  };
          break;
     case SCR_KEY_ENTER:
          ecode=SCR_EC_ENTER;
	  break;
     case SCR_KEY_ESC:
          ecode=SCR_EC_ESC;
	  break;
     default: //unrecognized 
          ecode=SCR_EC_UNK;
          break;
     };
viewer->startline=currstart;
	//scr_mvprintf(50,22,"%u",currstart);
scr_viewer_draw(viewer);
viewer->exittype=ecode;
return ecode;
}
