#ifndef SCR_TABLE_H
#define SCR_TABLE_H
#include "scr_ml.h"
//========== SPECIAL TABULAR-LIKE WIDGET ==========================

#define SCR_WT_SPECTABLE 21

typedef struct {
Scr_header header;
unsigned char fieldlen; //length of each field
unsigned int numfields; //number of fields
unsigned char (*coords)[2]; //pointer to array of screen coords
unsigned char* data; //pointer to data array 
char* currfield; //current edited field
unsigned char curspos; //current cursor position (in the field)
unsigned int currfieldnum; //current field
unsigned char editing; //edit state
unsigned char exittype; //copy of the exit code after injectchar
//unsigned char viewnow; //view mode
//pointer to function --- value validator
//if a pointer is NULL, then all chars are correct
int (*valinput)(char* value);
//pointer to function to display a value. Put string repres. into buffer 
//if a pointer is NULL, then simple sprintf("%u",value) is used 
void (*displvalue)(unsigned char value, char* buffer);
//should be malloced:
unsigned int (*links)[4]; //pointer to array of screen coords
} Scr_spectable;

int scr_spectable_valinput(char* value);
void scr_spectable_displvalue(unsigned char value, char* buffer);
Scr_spectable* scr_spectable_create(unsigned char x, unsigned char y, 
	unsigned char xlen, unsigned char ylen, unsigned char fieldlen,
	unsigned int numfields, unsigned char (*coords)[2],
        unsigned char* data);
void scr_spectable_destroy(Scr_spectable* table);
void scr_spectable_draw(Scr_spectable* table);
int scr_spectable_validate(Scr_spectable* table);
void scr_spectable_makelinks(Scr_spectable* table);
int scr_spectable_inject(Scr_spectable* table, int thechar);

#endif
